import java.util.Arrays;

public class Simulation {

    int dieCount;
    int rollCount;

    int minRoll;
    int maxRoll;

    Bins bins;
    Dice dice;

    public Simulation (int dieCount, int rollCount) {
        this.dieCount = dieCount;
        this.minRoll = dieCount;
        this.maxRoll = dieCount*6;
        this.rollCount = rollCount;
        this.bins = new Bins(minRoll, maxRoll);
        this.dice = new Dice(dieCount);
    }

    public void runSimulation(){
        for (int i = 0; i < rollCount; i++) {
            int currentRoll = dice.tossAndSum();
            bins.incrementBin(currentRoll);
        }
//        System.out.println(Arrays.deepToString(bins.binArray));
    }

    public void printResults() {
        StringBuilder builder = new StringBuilder("***\nSimulation of " + dieCount + " dice tossed " + rollCount + " times.\n***\n\n");


        // roll chart
        for (int i = 0; i < bins.binCount; i++) {
            // populate numbers and statistics for each
            int binNumber = i + minRoll;
            int rollValue = bins.getBin(binNumber);
            float rollStat = (float) rollValue / rollCount;
            builder.append(String.format("%3d :" + "%8d:" + " %.2f ", binNumber, rollValue, rollStat));
            // create graph
            int starCount = (int) (rollStat * 100);
            for (int j = 0; j < starCount; j++) {
                builder.append("*");
            }
            // next line
            builder.append("\n");
        }

        System.out.println(builder);
    }

}
