import org.junit.Assert;
import org.junit.Test;

import java.util.Arrays;

public class DiceTest {

    @Test
    public void tossAndSumTest0() {
        Dice dice = new Dice(2);

        long actualNumber = dice.tossAndSum();
        boolean test2To12 = 1 < actualNumber && actualNumber < 13;

        Assert.assertTrue(test2To12);
        System.out.println(actualNumber);

    }

    @Test
    public void tossAndSumTest1() {
        Dice dice = new Dice(10);

        long actualNumber = dice.tossAndSum();
        boolean test10To60 = 9 < actualNumber && actualNumber < 61;

        Assert.assertTrue(test10To60);
    }

    @Test
    public void binArrayTest1() {
        Bins bins = new Bins(3,18);

        int expectedValue = (3);

        Assert.assertEquals(expectedValue, bins.binArray[0][0]);
    }

    @Test
    public void binArrayTest2() {
        int maxRoll = 12;
        int minRoll = 2;
        Bins bins = new Bins(minRoll,maxRoll);

        int expectedValue = maxRoll;
        int bindex = maxRoll-minRoll;

        Assert.assertEquals(expectedValue, bins.binArray[bindex][0]);
    }

    @Test
    public void binArrayTest3() {
        int maxRoll = 6;
        int minRoll = 1;
        Bins bins = new Bins(minRoll,maxRoll);

        int expectedValue = maxRoll;
        int bindex = bins.binArray.length-1;

        Assert.assertEquals(expectedValue, bins.binArray[bindex][0]);
    }

    @Test
    public void getBinTest1() {
        Bins bins = new Bins(3,18);

        int expectedValue = (0);
        int actualValue = bins.getBin(3);

        Assert.assertEquals(expectedValue, actualValue);
    }

    @Test
    public void getBinTest2() {
        Bins bins = new Bins(2,12);

        int expectedValue = (0);
        int actualValue = bins.getBin(12);

        Assert.assertEquals(expectedValue, actualValue);
    }

    @Test
    public void incrementBinTest1() {
        Bins bins = new Bins(3,18);

        int expectedValue = (1);

        bins.incrementBin(3);
        int actualValue = bins.getBin(3);

//        System.out.println(Arrays.deepToString(bins.binArray));

        Assert.assertEquals(expectedValue, actualValue);
    }

}